//==============================================================================
// BasicSequence.hh
// ----------------------------------------------------------------------------
// Abstract base class for sequences (Sequence, Sequence3Bit, etc.) 
//
//------------------------------------------------------------------------------
// $Id: $
//------------------------------------------------------------------------------
// $Log: $
//
//==============================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8
//

#include "LocalSTL.hh"
#include "ParseUtils.hh"

#ifndef _BASICSEQUENCE
#define _BASICSEQUENCE




class BasicSequence {

public: 


	// Basic access
	virtual char GetBase() = 0;
	virtual void SetBase(int idx, char c)=0;

	// ....mainly for backward compability...
	virtual unsigned char operator()(size_type n) = 0;
	virtual unsigned char operator[](size_type n) = 0;


	// Basic operations 
	virtual void Reverse()=0;
	virtual void ReverseComplement()=0;
	virtual void Complement()=0;


	// Statistics 
	virtual int size()=0;

	
	
	// I/O 
	virtual friend ostream& operator<<(ostream& os,const BasicSequence &s) =0;

};
