//==============================================================================
// RandomNumberGenerator.hh
//
//==============================================================================
//.......1.........2.........3.........4.........5.........6.........7.........8
//

#ifndef _RNG
#define _RNG

#include "LocalSTL.hh"

//-----------------------------------------------------------------------------
// * RandomNumberGenerator
//-----------------------------------------------------------------------------
//
class RandomNumberGenerator{
public:

  RandomNumberGenerator(){
    SeedWithClock();
  }

  RandomNumberGenerator(unsigned long seed){
    setSeed(seed);
  }

  void setSeed(unsigned long seed){
    srandom((unsigned long) seed);
  }

  void   SeedWithClock();
  double Uniform(double start,double end);
  unsigned long Uniform(unsigned long start,unsigned long end);
  double Gaussian(double mean,double StdDev);

  // This is for STL, which wants a functor for random number generation. 
  //  unsigned long operator()(unsigned long n){
    
  // return(Uniform((unsigned long)0,(unsigned long) n-1));
  //}

  unsigned int operator()(unsigned int n){    
    unsigned int rval = Uniform((unsigned long)0,(unsigned long) n-1);
    cout<<"n="<<n<<"\trval="<<rval<<endl;
    if (rval >= n ){
      cerr<<"RNG ERROR"<<endl;
    }
    return(rval);
  }

};


#endif



